"use strict";

var _require = require('@babel/traverse'),
    traverse = _require.default,
    NodePath = _require.NodePath;

var t = require('@babel/types');
/**
 * Traverse a node path.
 * @param nodeOrPath
 * @param visitor
 */


module.exports = function traverseNodePath(nodeOrPath, visitor) {
  if (nodeOrPath == null) return;

  if (nodeOrPath instanceof NodePath) {
    nodeOrPath.traverse(visitor);
  } else if (t.isFile(nodeOrPath)) {
    traverse(nodeOrPath, visitor);
  } else if (t.isStatement(nodeOrPath)) {
    // Only can traverse file path.
    var file = t.file(t.program([nodeOrPath]));
    traverse(file, visitor);
  } else {
    // Expression should be wrapped in expression statement.
    // Only can traverse file path.
    var _file = t.file(t.program([t.expressionStatement(nodeOrPath)]));

    traverse(_file, visitor);
  }
};